/*
 *  smoke16/include/smoke16/asm.h - cpp macros for use in SMOKE-16 assembly programs
 *  $Revision: 1.11 $
 *  Copyright 1997, 1999, Benjamin Sittler
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef SMOKE16__ASM_H_INCLUDED
#define SMOKE16__ASM_H_INCLUDED

#define FUNCTION(name) \
	.align 1; \
	.global name; \
name:	push %ra; \
	mov %fp, [%sp]; \
	mov %sp, %fp; \
	sub 2, %sp

#define RET \
	mov %fp, %sp; \
	mov [%fp], %fp; \
	pop %ra; \
	ret

#endif /* SMOKE16__ASM_H_INCLUDED */
