// This may look like C code, but it is really -*- Asm -*-
/*
 *  smoke16/src16/close.s - Wrappers for the Mirrors system calls.
 *  $Revision: 1.3 $
 *  Copyright 1997, 2000, Benjamin Sittler
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include <smoke16/syscall.h>

// this file contains wrappers for the Mirrors syscalls. Errno
// may be affected.
	.text
	.align 1
// int close(int fd)
	.global _close
_close:	mov [_errno], %a1
	int SMOKE16_SYS_CLOSE
	mov %a1, [_errno]
	ret
