// This may look like C code, but it is really -*- Asm -*-
/*
 *  smoke16/src16/fgetc.s - Part of a sub-minimal SMOKE-16 I/O library.
 *  $Revision: 1.3 $
 *  Copyright 1997, 2000, Benjamin Sittler
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include <smoke16/asm.h>

	.text
	.align 1
// int getchar(void)
	.global _getchar
_getchar:
	mov [_stdin], %a0
// int fgetc(FILE *stream)
	FUNCTION(_fgetc)
	mov [%a0 + 2], %a1
	cmp %a1, %0
	bge fgetc0
	mov [%a0], %a0
	mov %sp, %a1
	push
	mov 1, %a2
	call _read
	cmp %a0, %0
	bg fgetc1
	mov -1, %a0
	pop
        b fgetc2
fgetc0:	mov -1, %a2
	mov %a2, [%a0 + 2]
	mov %a1, %a0
	b fgetc2
fgetc1: pop %a0
	srl 8, %a0
fgetc2: RET
