// This may look like C code, but it is really -*- Asm -*-
/*
 *  smoke16/src16/fprintd.s - Part of a sub-minimal SMOKE-16 I/O library.
 *  $Revision: 1.3 $
 *  Copyright 2000, Benjamin Sittler
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include <smoke16/asm.h>

	.text
	.align 1
// int printd(int d)
	.global _printd
_printd:
	mov [_stdout], %a1
// int fprintd(int d, FILE *stream)
	FUNCTION(_fprintd)
	push %t0
	push %t1
	push %t2
	mov %a0, %t0
	mov %a1, %t1
	mov %0, %t2
	cmp %a0, %0
	bge fprintd0
	movb '-', %a0
	call _fputc
	cmp %a0, %0
	bl fprintd2
	add 1, %t2
	sub %0, %t0, %t0
fprintd0:
	mov %t0, %a0
	mov 10, %a1
	call __sdiv
	mov %a1, %t0
	cmp %0, %a0
	be fprintd1
	mov %t1, %a1
	call _fprintd
	add %a0, %t2, %t2
fprintd1:
	movb '0', %a0
	add %a0, %t0, %a0
	mov %t1, %a1
	call _fputc
	cmp %a0, %0
	bl fprintd2
	add 1, %t2
fprintd2:
	mov %t2, %a0
	pop %t2
	pop %t1
	pop %t0
	RET
