// This may look like C code, but it is really -*- Asm -*-
/*
 *  smoke16/src16/ungetc.s - Part of a sub-minimal SMOKE-16 I/O library.
 *  $Revision: 1.2 $
 *  Copyright 2000, Benjamin Sittler
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include <smoke16/asm.h>

	.text
	.align 1
// int ungetc(int c, FILE *stream)
	.global _ungetc
_ungetc:
	mov [%a1 + 2], %a2
	cmp %a2, %0
	bge ungetc1
	sll %a0, 8, %a2
	srl %a2, 8, %a2
	mov %a2, [%a1 + 2]
	ret
ungetc1:
	mov %a2, %a0
	ret
